public abstract class AbstractStringList implements StringList
{
    public int loopingLength () {
        int count =0;
        StringList current = this;
        while (! (current instanceof ESL)) {
            current = ((NESL)current).getRest();
            count = count + 1;
        }
        return count;
    }
    
    public boolean equals (Object other)
    {
        if (! (other instanceof StringList))
        {
            return false;
        }
        else
        {
            /*
             * this     StringList
             * other    declared Object, actually StringList
             * this instanceof ESL      boolean
             * other instanceof ESL     boolean
             * this instanceof NESL     boolean
             * other instanceof NESL    boolean
             */
            
            StringList current = this;
            while (current instanceof NESL && other instanceof NESL)
            {
                NESL currentNESL = (NESL)current;
                NESL otherNESL = (NESL)other;
                if (! currentNESL.getFirst().equals(otherNESL.getFirst()))
                {
                    return false;
                }
                current = currentNESL.getRest();
                other = otherNESL.getRest();
            }
            return (current instanceof ESL && other instanceof ESL);
        }
    }
}
    

    
    
    
    